enchant_sys_events:
    type: world
    debug: false
    events:
        on item enchanted priority:-5:
            - define item     <context.item>
            - define cost     <context.cost>
            - define lore     <[item].lore.if_null[<list>]>
            - define enchants <context.enchants>
            # For each enchantment being applied...
            - foreach <context.enchants> key:enchantment as:level:
                # Skip if the enchant was removed from the enchant map
                - foreach next if:<[enchants].contains[<[enchantment]>].not>
                # Only do lore stuff if it's a denizen enchant
                - if <[enchantment].as[enchantment].key.starts_with[denizen]>:
                    - define ench <[enchantment].as[enchantment]>
                    - define lore_line <[ench].full_name[<[level]>].color[gray]>
                    - define lore_line "<element[Curse of <[ench].full_name[<[level]>]>].color[red]>" if:<[ench].is_curse>
                    - define lore:->:<[lore_line]>
                - definemap context:
                    entity: <context.entity>
                    location: <context.location>
                    inventory: <context.inventory>
                    button: <context.button>
                    other_enchantments: <[enchants].exclude[<[enchantment].after[:]>]>
                    cost: <[cost]>
                    item: <[item]>
                    enchantment: <[enchantment]>
                    level: <[level]>
                    lore: <[lore]>
                - customevent id:table_enchant_item context:<[context]> save:save
                # Cancel if the custom event cancelled
                - foreach next if:<entry[save].was_cancelled>
                # Determinations should come in the form of a single map entry, as custom event only handles adding to a list of outputs
                - define determines <entry[save].determination_list.first.as[map].if_null[<map>]>
                # Redefine values with ones from determination, if any
                - define item        <[determines.item]>        if:<[determines.item].exists>
                - define lore        <[determines.lore]>        if:<[determines.lore].exists>
                - define cost        <[determines.cost]>        if:<[determines.cost].exists>
                - define level       <[determines.level]>       if:<[determines.level].exists>
                - define enchants    <[determines.enchants]>    if:<[determines.enchants].exists>
                - define enchantment <[determines.enchantment]> if:<[determines.enchantment].exists>
            - determine passively enchants:<[enchants]>
            - determine passively result:<[item].with[lore=<[lore]>]>
            - determine passively <[cost]>
        on player prepares anvil craft item priority:-5:
            - define repair_cost    <context.repair_cost>
            - define new_name       <context.new_name>
            - define contents       <context.inventory.slot[1|2]>
            - define enchanted_book <[contents].last>
            - define item           <[contents].first>
            - define lore           <[item].lore.if_null[<list>]>
            - define item_enchants  <[item].enchantment_map>
            - define book_enchants  <[enchanted_book].enchantment_map>
            # Stop if recipe doesn't use an enchanted book
            - stop if:<[enchanted_book].advanced_matches[air]>
            # Stop if no denizen enchantments are present
            - stop if:<[book_enchants].is_empty>
            # When the repair costs are -1, then it's an item that vanilla MC doesn't
            # consider an enchantable item (such as a book). In such a case, we default
            # to an enchantment cost of 1. This is not a perfect fix, but if you wish
            # to modify this behaviour, you can always use the customenchant event.
            - define repair_cost 1 if:<[repair_cost].equals[-1]>
            # For every enchantment on the book...
            - foreach <[book_enchants]> key:enchantment as:level:
                - define enchantment  <[enchantment].as[enchantment]>
                - define lore_removed:!
                - define lore_line:!
                # By default, use "can_enchant" to determine if an item is enchantable...
                - define can_enchant <[enchantment].can_enchant[<[item]>]>
                 # HOWEVER, if an item is a denizen enchantment, then we want to check the script key
                # for the "can_enchant" property, as the "can_enchant" tag takes into account the
                # category of an item, which is almost certainly undesirable behaviour.
                - define can_enchant <[enchantment].script.parsed_key[can_enchant].if_null[true]> if:<[enchantment].key.starts_with[denizen]>
                # Skip the enchantment if it is not compatible with existing enchantments on item
                - foreach next if:<[item].enchantment_map.filter_tag[<[enchantment].is_compatible[<[filter_key]>]>].equals[<[item].enchantment_map>].not>
                # Skip this enchant if it can't enchant this item.
                - foreach next if:<[can_enchant].not>
                # Only handle adjusting lore if it's a custom denizen enchantment
                - if <[enchantment].key.starts_with[denizen]>:
                    - define lore_line  <[enchantment].full_name[<[level]>].color[gray]>
                    - define lore_line "<element[Curse of <[enchantment].full_name[<[level]>]>].color[red]>" if:<[enchantment].is_curse>
                    # If enchantment exists on item currently...
                    - if <[item_enchants].get[<[enchantment].name>].exists>:
                        - define item_level <[item_enchants].get[<[enchantment].name>]>
                        - define lore_line  <[enchantment].full_name[<[item_level]>].color[gray]>
                        - define lore_line "<element[Curse of <[enchantment].full_name[<[item_level]>]>].color[red]>" if:<[enchantment].is_curse>
                        # Skip processing if enchantment already present on item is the higher than the one on the book
                        - foreach next if:<[item_level].is_more_than[<[level]>]>
                        # If the level of the enchant being applied is the same as the one on the item, increase by one,
                        # otherwise increase the level up to the level being applied
                        - define level:++ if:<[level].equals[<[item_level]>]>
                        # Clamp level to between min and max of enchantment
                        - define level <[level].min[<[enchantment].max_level>].max[<[enchantment].min_level>]>
                        # keep track of the fact we removed that line, just in case we need to add it back in
                        - define lore_removed <[lore].find[<[lore_line]>]>
                        # Remove existing lore entry for this enchantment
                        - define lore:<-:<[lore_line]>
                # Create a tmp lore so we don't have to worry about removing an extra
                # line from lore if the event is cancelled.
                - define tmp_lore <[lore]>
                - define tmp_lore:->:<[lore_line]> if:<[lore_line].exists>
                - definemap context:
                    item: <[item]>
                    enchantment: <[enchantment]>
                    other_enchantments: <[book_enchants].exclude[<[enchantment].key.after[:]>]>
                    level: <[level]>
                    lore: <[tmp_lore]>
                    repair_cost: <[repair_cost]>
                    new_name: <[new_name]>
                    inventory: <context.inventory>
                # Fire a custom event for enchanting the item through an anvil
                - customevent id:anvil_enchant_item context:<[context]> save:save
                # If the event was cancelled, add in our removed line of lore (if
                # we removed a line of lore), so that we "reset" back to the state
                # we were before, and then skip to the next enchantment.
                - if <entry[save].was_cancelled>:
                    - define lore <[lore].insert[<[lore_line]>].at[<[lore_removed]>]> if:<[lore_removed].exists>
                    - foreach next if:<entry[save].was_cancelled>
                # Fully add enchantment lore to list, now that we know the enchant is being added
                - define lore <[tmp_lore]>
                # Determinations should come in the form of a single map entry, as custom event only handles adding to a list of outputs
                - define determines <entry[save].determination_list.first.as[map].if_null[<map>]>
                # Redefine values with ones from determination, if any
                - define item        <[determines.item]>        if:<[determines.item].exists>
                - define lore        <[determines.lore]>        if:<[determines.lore].exists>
                - define level       <[determines.level]>       if:<[determines.level].exists>
                - define new_name    <[determines.new_name]>    if:<[determines.new_name].exists>
                - define repair_cost <[determines.repair_cost]> if:<[determines.repair_cost].exists>
                - define enchantment <[determines.enchantment]> if:<[determines.enchantment].exists>
                # Add enchantment to enchantment map
                - define item_enchants.<[enchantment].name>:<[level]>
            # If there are no custom enchants, then we want to check if
            - stop if:<[item_enchants].is_empty>
            # Add lore and enchantment map to item
            - determine passively <[item].with[display=<[new_name]>;lore=<[lore]>;enchantments=<[item_enchants]>]>
            - determine passively <[repair_cost]>